<!--
 * @Author: zhp
 * @Date: 2023-02-14 15:02:26
 * @LastEditTime: 2023-07-19 16:10:31
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-form :model="dataForm" ref="dataForm" :rules="dataRule" @keyup.enter.native="dataFormSubmitHandle()"
    label-width="120px">
    <el-form-item prop="title" :label="$t('researchquality.title')">
      <el-input v-model="dataForm.title" :placeholder="$t('researchquality.title')">
      </el-input>
    </el-form-item>
    <el-form-item prop="requirementListGroupId" :label="$t('researchquality.requirementListGroupId')">
      <el-select v-model="dataForm.requirementListGroupId" :placeholder="$t('researchquality.requirementListGroupId')">
        <el-option v-for="item in projectTypeList" :key="item.id" :label="item.name" :value="item.id">
        </el-option>
      </el-select>
    </el-form-item>
    <el-form-item prop="description" :label="$t('researchquality.description')">
      <el-input v-model="dataForm.description" :placeholder="$t('researchquality.description')">
      </el-input>
    </el-form-item>
  </el-form>
</template>

<script>
import debounce from "lodash/debounce";
import basicAdd from "@/mixins/basic-add";
export default {
  mixins: [basicAdd],
  data() {
    return {
      urlOptions: {
        submitURL: "/researchquality/qmsQualityRequirementList",
        infoURL: "/researchquality/qmsQualityRequirementList/{id}",
        getProjectTypeURL: '/researchquality/qmsQualityRequirementListGroup/page',
        // getCodeURL: '/supplier/qmsEvaluationItemList/getCode'
      },
      options: [{
        value: 0,
        label: '不可用'
      },
      {
        value: 1,
        label: '可用'
        }],
      supplierList:null,
      enterpriseNatureList: [
        {
          value: 0,
          label: '私营'
        },
        {
          value: 1,
          label: '国有'
        },
           {
          value: 2,
          label: '外资'
        },
           {
          value: 3,
          label: '其他'
        }
      ],
      projectTypeList:[],
      visible: false,
      listQuery: {
        limit: 999,
        page:1
      },
      dataForm: {
        id: "",
        title:null,
        requirementListGroupId: undefined,
        description: null
      },
    };
  },
  computed: {
    dataRule() {
      return {
        title: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ]
      };
    },
  },
  mounted () {
    this.getDict();
  },
  methods: {
    init(data,) {
      console.log(data)
      // this.dataForm.dictTypeId = dictTypeId || "";
      this.visible = true;
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields()
        if (data) {
          this.dataForm.id = data.id ? data.id : ''
          this.dataForm.requirementListGroupId = data.requirementListGroupId ? data.requirementListGroupId : ''
        }
        if (this.dataForm.id) {
          this.getInfo()
        }
      });
    },
    getDict() {
      this.$http
        .get(this.urlOptions.getProjectTypeURL, { params: this.listQuery })
        .then(({ data: res }) => {
          if (res.code === 0) {
            console.log(res.data);
            this.projectTypeList = res.data.list
          }
        })
        .catch(() => {
        })
    },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/researchquality/qmsQualityRequirementList/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
        })
        .catch(() => {});
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[!this.dataForm.id ? "post" : "put"](this.urlOptions.submitURL, this.dataForm)
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  console.log(1111);
                  this.visible = false;
                  this.$emit("successSubmit");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>
